#!/bin/bash
cd files

yes_no(){
	YESNOARG="$1"
	echo "$YESNOARG"
        read -p "Type Y to continue or N to break. [Yes/No]:" YO
	[ "$YO" != "N" -a "$YO" != "Y" -a "$YO" != "y" -a "$YO" != "n" ] && \
	yes_no 
        [ "$YO" = "N" -o "$YO" = "n" ] && return 1
        [ "$YO" = "Y" -o "$YO" = "y" ] && return 0
}

check_stuff(){
echo "################ Checking needed stuff ################"
for i in adb gpsd ncat netstat; do
	RESULT=`which $i`
	printf "Checking $i "
	if [ -z "$RESULT" ]; then
	echo "- NOT FOUND
Install $i or, if You have it in place not set in default environement
set full path in /usr/local/bin/adb_gps_usb.sh Definitions section"
	yes_no || exit 1
	else
	echo "- found as $RESULT - ##OK##"
	fi
done
echo "######################################################"
}

check_id(){
echo "############### Checking phone model #################"
echo "
Unplug your phone and press [Enter]"
read YO
#echo 
udevadm monitor --prop | grep ID_MODEL= >> MODEL.tmp & 
echo "Now plug it back, wait about 10 seconds then press [Enter]"
tailf MODEL.tmp &
read YO
killall tailf 2>&1
killall udevadm 2>&1
#clear
for i in `cat MODEL.tmp`; do echo $i | grep -v Card; done | tail -n 1 > MODEL
. ./MODEL
echo "Your phone model (by udev) is $ID_MODEL"
answer1
echo "######################################################"
}


installit(){
echo "################# Installing stuff ####################"
echo "Setting as $ID_MODEL"
#SEDATTR="-e s/MYPHONE_ID/${ID_MODEL}/g"
#echo $SEDATTR
#sed $SEDATTR 65-adb_gps_usb.tmp > 65-adb_gps_usb.rules
sed -e s/MYPHONE_ID/${ID_MODEL}/g  65-adb_gps_usb.tmp > 65-adb_gps_usb.rules
echo "Copying files & setting udev"
cp 65-adb_gps_usb.rules /etc/udev/rules.d/65-adb_gps_usb.rules
cp adb_gps* /usr/local/bin/
chmod 644 /etc/udev/rules.d/65-adb_gps_usb.rules
chmod 755 /usr/local/bin/adb_gps*
chown root:root /usr/local/bin/adb_gps* 
udevadm trigger
echo "#################### Done ############################"
echo "Cleaning temporaries"
rm 65-adb_gps_usb.rules MODEL.tmp MODEL
exit 0
}

answer1(){
yes_no "ID_MODEL=$ID_MODEL - ok?" && installit
read -p "To check it again  type \"again\"; to break type anything else.: " AGAIN
[ "$AGAIN" = "again" ] &&  check_id || exit 1
}

[ `id -u` -ne 0 ] && echo "This script needs admin privileges
Login as root or use sudo command (#sudo ./install.sh)" && exit 1
check_stuff
check_id
echo "Bye" 
